Index: /trunk/sources/LibSVM/Solver.cs
===================================================================
--- /trunk/sources/LibSVM/Solver.cs	(revision 2414)
+++ /trunk/sources/LibSVM/Solver.cs	(revision 2415)
@@ -954,19 +796,24 @@
                     if (y[i] == +1)
                     {
-                        if (G[i] > Gmax2) Gmax2 = G[i];
-                    }
-                    else if (G[i] > Gmax3) Gmax3 = G[i];
-                }
-            }
-
-            // shrinking
+                        if (G[i] > GMax2) GMax2 = G[i];
+                    }
+                    else if (G[i] > GMax3) GMax3 = G[i];
+                }
+            }
+
+            if (unshrink == false && Math.Max(GMax1 + GMax2, GMax3 + GMax4) <= EPS * 10)
+            {
+                unshrink = true;
+                reconstruct_gradient();
+                active_size = l;
+            }
 
             for (i = 0; i < active_size; i++)
-                if (be_shrunken(i, Gmax1, Gmax2, Gmax3, Gmax4))
+                if (be_shrunk(i, GMax1, GMax2, GMax3, GMax4))
                 {
                     active_size--;
                     while (active_size > i)
                     {
-                        if (!be_shrunken(active_size, Gmax1, Gmax2, Gmax3, Gmax4))
+                        if (!be_shrunk(active_size, GMax1, GMax2, GMax3, GMax4))
                         {
                             swap_index(i, active_size);
@@ -976,27 +823,7 @@
                     }
                 }
-
-            if (unshrinked || Math.Max(Gmax1 + Gmax2, Gmax3 + Gmax4) > eps * 10) return;
-
-            unshrinked = true;
-            reconstruct_gradient();
-
-            for (i = l - 1; i >= active_size; i--)
-                if (!be_shrunken(i, Gmax1, Gmax2, Gmax3, Gmax4))
-                {
-                    while (active_size < i)
-                    {
-                        if (be_shrunken(active_size, Gmax1, Gmax2, Gmax3, Gmax4))
-                        {
-                            swap_index(i, active_size);
-                            break;
-                        }
-                        active_size++;
-                    }
-                    active_size++;
-                }
-        }
-
-        protected override double calculate_rho()
+        }
+
+        private double calculate_rho()
         {
             int nr_free1 = 0, nr_free2 = 0;
@@ -1054,40 +881,40 @@
     class SVC_Q : Kernel
     {
-        private short[] y;
+        private sbyte[] y;
         private Cache cache;
         private float[] QD;
 
-        public SVC_Q(Problem prob, Parameter param, short[] y_) : base(prob.Count, prob.X, param)
-        {
-            y = (short[])y_.Clone();
+        public SVC_Q(Problem prob, Parameter param, sbyte[] y_) : base(prob.Count, prob.X, param)
+        {
+            y = (sbyte[])y_.Clone();
             cache = new Cache(prob.Count, (long)(param.CacheSize * (1 << 20)));
             QD = new float[prob.Count];
             for (int i = 0; i < prob.Count; i++)
-                QD[i] = (float)kernel_function(i, i);
-        }
-
-        public override float[] get_Q(int i, int len)
-        {
-            float[][] data = new float[1][];
-            int start;
-            if ((start = cache.get_data(i, data, len)) < len)
-            {
-                for (int j = start; j < len; j++)
-                    data[0][j] = (float)(y[i] * y[j] * kernel_function(i, j));
-            }
-            return data[0];
-        }
-
-        public override float[] get_QD()
+                QD[i] = (float)KernelFunction(i, i);
+        }
+
+        public override sealed float[] GetQ(int i, int len)
+        {
+            float[] data = null;
+            int start, j;
+            if ((start = cache.GetData(i, ref data, len)) < len)
+            {
+                for (j = start; j < len; j++)
+                    data[j] = (float)(y[i] * y[j] * KernelFunction(i, j));
+            }
+            return data;
+        }
+
+        public override sealed float[] GetQD()
         {
             return QD;
         }
 
-        public override void swap_index(int i, int j)
-        {
-            cache.swap_index(i, j);
-            base.swap_index(i, j);
-            do { short _ = y[i]; y[i] = y[j]; y[j] = _; } while (false);
-            do { float _ = QD[i]; QD[i] = QD[j]; QD[j] = _; } while (false);
+        public override sealed void SwapIndex(int i, int j)
+        {
+            cache.SwapIndex(i, j);
+            base.SwapIndex(i, j);
+            y.SwapIndex(i, j);
+            QD.SwapIndex(i, j);
         }
     }
@@ -1098,34 +925,34 @@
         private float[] QD;
 
-        public ONE_CLASS_Q(Problem prob, Parameter param) : base(prob.Count, prob.X, param)
+        public ONE_CLASS_Q(Problem prob, Parameter param) :  base(prob.Count, prob.X, param)
         {
             cache = new Cache(prob.Count, (long)(param.CacheSize * (1 << 20)));
             QD = new float[prob.Count];
             for (int i = 0; i < prob.Count; i++)
-                QD[i] = (float)kernel_function(i, i);
-        }
-
-        public override float[] get_Q(int i, int len)
-        {
-            float[][] data = new float[1][];
-            int start;
-            if ((start = cache.get_data(i, data, len)) < len)
-            {
-                for (int j = start; j < len; j++)
-                    data[0][j] = (float)kernel_function(i, j);
-            }
-            return data[0];
-        }
-
-        public override float[] get_QD()
+                QD[i] = (float)KernelFunction(i, i);
+        }
+
+        public override sealed float[] GetQ(int i, int len)
+        {
+            float[] data = null;
+            int start, j;
+            if ((start = cache.GetData(i, ref data, len)) < len)
+            {
+                for (j = start; j < len; j++)
+                    data[j] = (float)KernelFunction(i, j);
+            }
+            return data;
+        }
+
+        public override sealed float[] GetQD()
         {
             return QD;
         }
 
-        public override void swap_index(int i, int j)
-        {
-            cache.swap_index(i, j);
-            base.swap_index(i, j);
-            do { float _ = QD[i]; QD[i] = QD[j]; QD[j] = _; } while (false);
+        public override sealed void SwapIndex(int i, int j)
+        {
+            cache.SwapIndex(i, j);
+            base.SwapIndex(i, j);
+            QD.SwapIndex(i, j);
         }
     }
@@ -1135,5 +962,5 @@
         private int l;
         private Cache cache;
-        private short[] sign;
+        private sbyte[] sign;
         private int[] index;
         private int next_buffer;
@@ -1141,11 +968,10 @@
         private float[] QD;
 
-        public SVR_Q(Problem prob, Parameter param)
-            : base(prob.Count, prob.X, param)
+        public SVR_Q(Problem prob, Parameter param) : base(prob.Count, prob.X, param)
         {
             l = prob.Count;
             cache = new Cache(l, (long)(param.CacheSize * (1 << 20)));
             QD = new float[2 * l];
-            sign = new short[2 * l];
+            sign = new sbyte[2 * l];
             index = new int[2 * l];
             for (int k = 0; k < l; k++)
@@ -1155,5 +981,5 @@
                 index[k] = k;
                 index[k + l] = k;
-                QD[k] = (float)kernel_function(k, k);
+                QD[k] = (float)KernelFunction(k, k);
                 QD[k + l] = QD[k];
             }
@@ -1164,19 +990,19 @@
         }
 
-        public override void swap_index(int i, int j)
-        {
-            do { short _ = sign[i]; sign[i] = sign[j]; sign[j] = _; } while (false);
-            do { int _ = index[i]; index[i] = index[j]; index[j] = _; } while (false);
-            do { float _ = QD[i]; QD[i] = QD[j]; QD[j] = _; } while (false);
-        }
-
-        public override float[] get_Q(int i, int len)
-        {
-            float[][] data = new float[1][];
-            int real_i = index[i];
-            if (cache.get_data(real_i, data, l) < l)
-            {
-                for (int j = 0; j < l; j++)
-                    data[0][j] = (float)kernel_function(real_i, j);
+        public override sealed void SwapIndex(int i, int j)
+        {
+            sign.SwapIndex(i, j);
+            index.SwapIndex(i, j);
+            QD.SwapIndex(i, j);
+        }
+
+        public override sealed float[] GetQ(int i, int len)
+        {
+            float[] data = null;
+            int j, real_i = index[i];
+            if (cache.GetData(real_i, ref data, l) < l)
+            {
+                for (j = 0; j < l; j++)
+                    data[j] = (float)KernelFunction(real_i, j);
             }
 
@@ -1184,11 +1010,11 @@
             float[] buf = buffer[next_buffer];
             next_buffer = 1 - next_buffer;
-            short si = sign[i];
-            for (int j = 0; j < len; j++)
-                buf[j] = si * sign[j] * data[0][index[j]];
+            sbyte si = sign[i];
+            for (j = 0; j < len; j++)
+                buf[j] = (float)si * sign[j] * data[index[j]];
             return buf;
         }
 
-        public override float[] get_QD()
+        public override sealed float[] GetQD()
         {
             return QD;
@@ -1196,9 +1022,31 @@
     }
 
-    internal static class Procedures
+    internal class Procedures
     {
+        private static bool _verbose;
+        public static bool IsVerbose
+        {
+            get
+            {
+                return _verbose;
+            }
+            set
+            {
+                _verbose = value;
+            }
+        }
         //
         // construct and solve various formulations
         //
+        public const int LIBSVM_VERSION = 289;
+
+        public static TextWriter svm_print_string = Console.Out;
+
+        public static void info(string s)
+        {
+            if(_verbose)
+                svm_print_string.Write(s);
+        }
+
         private static void solve_c_svc(Problem prob, Parameter param,
                         double[] alpha, Solver.SolutionInfo si,
@@ -1206,6 +1054,6 @@
         {
             int l = prob.Count;
-            double[] minus_ones = new double[l];
-            short[] y = new short[l];
+            double[] Minus_ones = new double[l];
+            sbyte[] y = new sbyte[l];
 
             int i;
@@ -1214,10 +1062,10 @@
             {
                 alpha[i] = 0;
-                minus_ones[i] = -1;
+                Minus_ones[i] = -1;
                 if (prob.Y[i] > 0) y[i] = +1; else y[i] = -1;
             }
 
             Solver s = new Solver();
-            s.Solve(l, new SVC_Q(prob, param, y), minus_ones, y,
+            s.Solve(l, new SVC_Q(prob, param, y), Minus_ones, y,
                 alpha, Cp, Cn, param.EPS, si, param.Shrinking);
 
@@ -1227,5 +1075,5 @@
 
             if (Cp == Cn)
-                Debug.Write("nu = " + sum_alpha / (Cp * prob.Count) + "\n");
+                Procedures.info("nu = " + sum_alpha / (Cp * prob.Count) + "\n");
 
             for (i = 0; i < l; i++)
@@ -1240,5 +1088,5 @@
             double nu = param.Nu;
 
-            short[] y = new short[l];
+            sbyte[] y = new sbyte[l];
 
             for (i = 0; i < l; i++)
@@ -1269,9 +1117,8 @@
 
             Solver_NU s = new Solver_NU();
-            s.Solve(l, new SVC_Q(prob, param, y), zeros, y,
-                alpha, 1.0, 1.0, param.EPS, si, param.Shrinking);
+            s.Solve(l, new SVC_Q(prob, param, y), zeros, y, alpha, 1.0, 1.0, param.EPS, si, param.Shrinking);
             double r = si.r;
 
-            Debug.Write("C = " + 1 / r + "\n");
+            Procedures.info("C = " + 1 / r + "\n");
 
             for (i = 0; i < l; i++)
@@ -1285,9 +1132,9 @@
 
         private static void solve_one_class(Problem prob, Parameter param,
-                            double[] alpha, Solver.SolutionInfo si)
+                        double[] alpha, Solver.SolutionInfo si)
         {
             int l = prob.Count;
             double[] zeros = new double[l];
-            short[] ones = new short[l];
+            sbyte[] ones = new sbyte[l];
             int i;
 
@@ -1308,15 +1155,13 @@
 
             Solver s = new Solver();
-            s.Solve(l, new ONE_CLASS_Q(prob, param), zeros, ones,
-                alpha, 1.0, 1.0, param.EPS, si, param.Shrinking);
-        }
-
-        private static void solve_epsilon_svr(Problem prob, Parameter param,
-                        double[] alpha, Solver.SolutionInfo si)
+            s.Solve(l, new ONE_CLASS_Q(prob, param), zeros, ones, alpha, 1.0, 1.0, param.EPS, si, param.Shrinking);
+        }
+
+        private static void solve_epsilon_svr(Problem prob, Parameter param, double[] alpha, Solver.SolutionInfo si)
         {
             int l = prob.Count;
             double[] alpha2 = new double[2 * l];
             double[] linear_term = new double[2 * l];
-            short[] y = new short[2 * l];
+            sbyte[] y = new sbyte[2 * l];
             int i;
 
@@ -1333,6 +1178,5 @@
 
             Solver s = new Solver();
-            s.Solve(2 * l, new SVR_Q(prob, param), linear_term, y,
-                alpha2, param.C, param.C, param.EPS, si, param.Shrinking);
+            s.Solve(2 * l, new SVR_Q(prob, param), linear_term, y, alpha2, param.C, param.C, param.EPS, si, param.Shrinking);
 
             double sum_alpha = 0;
@@ -1342,5 +1186,5 @@
                 sum_alpha += Math.Abs(alpha[i]);
             }
-            Debug.Write("nu = " + sum_alpha / (param.C * l) + "\n");
+            Procedures.info("nu = " + sum_alpha / (param.C * l) + "\n");
         }
 
@@ -1352,5 +1196,5 @@
             double[] alpha2 = new double[2 * l];
             double[] linear_term = new double[2 * l];
-            short[] y = new short[2 * l];
+            sbyte[] y = new sbyte[2 * l];
             int i;
 
@@ -1371,5 +1215,5 @@
             s.Solve(2 * l, new SVR_Q(prob, param), linear_term, y, alpha2, C, C, param.EPS, si, param.Shrinking);
 
-            Debug.Write("epsilon = " + (-si.r) + "\n");
+            Procedures.info("epsilon = " + (-si.r) + "\n");
 
             for (i = 0; i < l; i++)
@@ -1380,5 +1224,5 @@
         // decision_function
         //
-        private class decision_function
+        internal class decision_function
         {
             public double[] alpha;
@@ -1386,7 +1230,5 @@
         };
 
-        static decision_function svm_train_one(
-            Problem prob, Parameter param,
-            double Cp, double Cn)
+        static decision_function svm_train_one(Problem prob, Parameter param, double Cp, double Cn)
         {
             double[] alpha = new double[prob.Count];
@@ -1411,5 +1253,5 @@
             }
 
-            Debug.Write("obj = " + si.obj + ", rho = " + si.rho + "\n");
+            Procedures.info("obj = " + si.obj + ", rho = " + si.rho + "\n");
 
             // output SVs
@@ -1435,5 +1277,5 @@
             }
 
-            Debug.Write("nSV = " + nSV + ", nBSV = " + nBSV + "\n");
+            Procedures.info("nSV = " + nSV + ", nBSV = " + nBSV + "\n");
 
             decision_function f = new decision_function();
@@ -1455,7 +1297,7 @@
                 else prior0 += 1;
 
-            int max_iter = 100; 	// Maximal number of iterations
-            double min_step = 1e-10;	// Minimal step taken in line search
-            double sigma = 1e-3;	// For numerically strict PD of Hessian
+            int Max_iter = 100;	// Maximal number of iterations
+            double Min_step = 1e-10;	// Minimal step taken in line search
+            double sigma = 1e-12;	// For numerically strict PD of Hessian
             double eps = 1e-5;
             double hiTarget = (prior1 + 1.0) / (prior1 + 2.0);
@@ -1480,5 +1322,5 @@
                     fval += (t[i] - 1) * fApB + Math.Log(1 + Math.Exp(fApB));
             }
-            for (iter = 0; iter < max_iter; iter++)
+            for (iter = 0; iter < Max_iter; iter++)
             {
                 // Update Gradient and Hessian (use H' = H + sigma I)
@@ -1519,6 +1361,6 @@
 
 
-                stepsize = 1; 		// Line Search
-                while (stepsize >= min_step)
+                stepsize = 1;		// Line Search
+                while (stepsize >= Min_step)
                 {
                     newA = A + stepsize * dA;
@@ -1545,13 +1387,13 @@
                 }
 
-                if (stepsize < min_step)
-                {
-                    Debug.Write("Line search fails in two-class probability estimates\n");
+                if (stepsize < Min_step)
+                {
+                    Procedures.info("Line search fails in two-class probability estimates\n");
                     break;
                 }
             }
 
-            if (iter >= max_iter)
-                Debug.Write("Reaching maximal iterations in two-class probability estimates\n");
+            if (iter >= Max_iter)
+                Procedures.info("Reaching Maximal iterations in two-class probability estimates\n");
             probAB[0] = A; probAB[1] = B;
         }
@@ -1568,66 +1410,65 @@
         // Method 2 from the multiclass_prob paper by Wu, Lin, and Weng
         private static void multiclass_probability(int k, double[,] r, double[] p)
-	{
-		int t,j;
-		int iter = 0, max_iter=Math.Max(100,k);
-		double[,] Q=new double[k,k];
-		double[] Qp= new double[k];
-		double pQp, eps=0.005/k;
-	
-		for (t=0;t<k;t++)
-		{
-			p[t]=1.0/k;  // Valid if k = 1
-			Q[t,t]=0;
-			for (j=0;j<t;j++)
-			{
-				Q[t,t]+=r[j,t]*r[j,t];
-				Q[t,j]=Q[j,t];
-			}
-			for (j=t+1;j<k;j++)
-			{
-				Q[t,t]+=r[j,t]*r[j,t];
-				Q[t,j]=-r[j,t]*r[t,j];
-			}
-		}
-		for (iter=0;iter<max_iter;iter++)
-		{
-			// stopping condition, recalculate QP,pQP for numerical accuracy
-			pQp=0;
-			for (t=0;t<k;t++)
-			{
-				Qp[t]=0;
-				for (j=0;j<k;j++)
-					Qp[t]+=Q[t,j]*p[j];
-				pQp+=p[t]*Qp[t];
-			}
-			double max_error=0;
-			for (t=0;t<k;t++)
-			{
-				double error=Math.Abs(Qp[t]-pQp);
-				if (error>max_error)
-					max_error=error;
-			}
-			if (max_error<eps) break;
-		
-			for (t=0;t<k;t++)
-			{
-				double diff=(-Qp[t]+pQp)/Q[t,t];
-				p[t]+=diff;
-				pQp=(pQp+diff*(diff*Q[t,t]+2*Qp[t]))/(1+diff)/(1+diff);
-				for (j=0;j<k;j++)
-				{
-					Qp[j]=(Qp[j]+diff*Q[t,j])/(1+diff);
-					p[j]/=(1+diff);
-				}
-			}
-		}
-		if (iter>=max_iter)
-			Debug.Write("Exceeds max_iter in multiclass_prob\n");
-	}
+        {
+            int t, j;
+            int iter = 0, Max_iter = Math.Max(100, k);
+            double[,] Q = new double[k,k];
+            double[] Qp = new double[k];
+            double pQp, eps = 0.005 / k;
+
+            for (t = 0; t < k; t++)
+            {
+                p[t] = 1.0 / k;  // Valid if k = 1
+                Q[t,t] = 0;
+                for (j = 0; j < t; j++)
+                {
+                    Q[t,t] += r[j,t] * r[j,t];
+                    Q[t,j] = Q[j,t];
+                }
+                for (j = t + 1; j < k; j++)
+                {
+                    Q[t,t] += r[j,t] * r[j,t];
+                    Q[t,j] = -r[j,t] * r[t,j];
+                }
+            }
+            for (iter = 0; iter < Max_iter; iter++)
+            {
+                // stopping condition, recalculate QP,pQP for numerical accuracy
+                pQp = 0;
+                for (t = 0; t < k; t++)
+                {
+                    Qp[t] = 0;
+                    for (j = 0; j < k; j++)
+                        Qp[t] += Q[t,j] * p[j];
+                    pQp += p[t] * Qp[t];
+                }
+                double Max_error = 0;
+                for (t = 0; t < k; t++)
+                {
+                    double error = Math.Abs(Qp[t] - pQp);
+                    if (error > Max_error)
+                        Max_error = error;
+                }
+                if (Max_error < eps) break;
+
+                for (t = 0; t < k; t++)
+                {
+                    double diff = (-Qp[t] + pQp) / Q[t,t];
+                    p[t] += diff;
+                    pQp = (pQp + diff * (diff * Q[t,t] + 2 * Qp[t])) / (1 + diff) / (1 + diff);
+                    for (j = 0; j < k; j++)
+                    {
+                        Qp[j] = (Qp[j] + diff * Q[t,j]) / (1 + diff);
+                        p[j] /= (1 + diff);
+                    }
+                }
+            }
+            if (iter >= Max_iter)
+                Procedures.info("Exceeds Max_iter in multiclass_prob\n");
+        }
 
         // Cross-validation decision values for probability estimates
         private static void svm_binary_svc_probability(Problem prob, Parameter param, double Cp, double Cn, double[] probAB)
         {
-            Random rand = new Random();
             int i;
             int nr_fold = 5;
@@ -1636,4 +1477,5 @@
 
             // random shuffle
+            Random rand = new Random();
             for (i = 0; i < prob.Count; i++) perm[i] = i;
             for (i = 0; i < prob.Count; i++)
@@ -1687,11 +1529,6 @@
                     subparam.Probability = false;
                     subparam.C = 1.0;
-                    subparam.WeightCount = 2;
-                    subparam.WeightLabels = new int[2];
-                    subparam.Weights = new double[2];
-                    subparam.WeightLabels[0] = +1;
-                    subparam.WeightLabels[1] = -1;
-                    subparam.Weights[0] = Cp;
-                    subparam.Weights[1] = Cn;
+                    subparam.Weights[1] = Cp;
+                    subparam.Weights[-1] = Cn;
                     Model submodel = svm_train(subprob, subparam);
                     for (j = begin; j < end; j++)
@@ -1718,5 +1555,5 @@
             Parameter newparam = (Parameter)param.Clone();
             newparam.Probability = false;
-            svm_cross_validation(prob, newparam, nr_fold, ymv, null);
+            svm_cross_validation(prob, newparam, nr_fold, ymv);
             for (i = 0; i < prob.Count; i++)
             {
@@ -1734,5 +1571,5 @@
                     mae += Math.Abs(ymv[i]);
             mae /= (prob.Count - count);
-            Debug.Write("Prob. model for test data: target value = predicted value + z,\nz: Laplace distribution e^(-|z|/sigma)/(2sigma),sigma=" + mae + "\n");
+            Procedures.info("Prob. model for test data: target value = predicted value + z,\nz: Laplace distribution e^(-|z|/sigma)/(2sigma),sigma=" + mae + "\n");
             return mae;
         }
@@ -1743,8 +1580,8 @@
         {
             int l = prob.Count;
-            int max_nr_class = 16;
+            int Max_nr_class = 16;
             int nr_class = 0;
-            int[] label = new int[max_nr_class];
-            int[] count = new int[max_nr_class];
+            int[] label = new int[Max_nr_class];
+            int[] count = new int[Max_nr_class];
             int[] data_label = new int[l];
             int i;
@@ -1765,11 +1602,11 @@
                 if (j == nr_class)
                 {
-                    if (nr_class == max_nr_class)
-                    {
-                        max_nr_class *= 2;
-                        int[] new_data = new int[max_nr_class];
+                    if (nr_class == Max_nr_class)
+                    {
+                        Max_nr_class *= 2;
+                        int[] new_data = new int[Max_nr_class];
                         Array.Copy(label, 0, new_data, 0, label.Length);
                         label = new_data;
-                        new_data = new int[max_nr_class];
+                        new_data = new int[Max_nr_class];
                         Array.Copy(count, 0, new_data, 0, count.Length);
                         count = new_data;
@@ -1808,15 +1645,15 @@
             model.Parameter = param;
 
-            if (param.SvmType == SvmType.ONE_CLASS ||
+            if (param.SvmType == SvmType.ONE_CLASS || 
                param.SvmType == SvmType.EPSILON_SVR ||
                param.SvmType == SvmType.NU_SVR)
             {
                 // regression or one-class-svm
-                model.NumberOfClasses = 2;
+                model.NumberOfClasses = 2;                
                 model.ClassLabels = null;
                 model.NumberOfSVPerClass = null;
                 model.PairwiseProbabilityA = null; model.PairwiseProbabilityB = null;
                 model.SupportVectorCoefficients = new double[1][];
-
+                
                 if (param.Probability &&
                    (param.SvmType == SvmType.EPSILON_SVR ||
@@ -1834,5 +1671,5 @@
                 int i;
                 for (i = 0; i < prob.Count; i++)
-                    if (Math.Abs(f.alpha[i]) > 0) ++nSV;
+                    if (Math.Abs(f.alpha[i]) > 0) ++nSV;                
                 model.SupportVectorCount = nSV;
                 model.SupportVectors = new Node[nSV][];
@@ -1873,14 +1710,10 @@
                 for (i = 0; i < nr_class; i++)
                     weighted_C[i] = param.C;
-                for (i = 0; i < param.WeightCount; i++)
-                {
-                    int j;
-                    for (j = 0; j < nr_class; j++)
-                        if (param.WeightLabels[i] == label[j])
-                            break;
-                    if (j == nr_class)
-                        Debug.Write("warning: class label " + param.WeightLabels[i] + " specified in weight is not found\n");
-                    else
-                        weighted_C[j] *= param.Weights[i];
+                foreach (int weightedLabel in param.Weights.Keys)
+                {
+                    int index = Array.IndexOf<int>(label, weightedLabel);
+                    if (index < 0)
+                        Console.Error.WriteLine("warning: class label " + weightedLabel + " specified in weight is not found");
+                    else weighted_C[index] *= param.Weights[weightedLabel];
                 }
 
@@ -1983,5 +1816,5 @@
                 }
 
-                Debug.Write("Total nSV = " + nnz + "\n");
+                Procedures.info("Total nSV = " + nnz + "\n");
 
                 model.SupportVectorCount = nnz;
@@ -2029,5 +1862,5 @@
 
         // Stratified cross validation
-        public static void svm_cross_validation(Problem prob, Parameter param, int nr_fold, double[] target, Dictionary<int,double>[] confidence)
+        public static void svm_cross_validation(Problem prob, Parameter param, int nr_fold, double[] target)
         {
             Random rand = new Random();
@@ -2131,13 +1964,7 @@
                     param.SvmType == SvmType.NU_SVC))
                 {
+                    double[] prob_estimates = new double[svm_get_nr_class(submodel)];
                     for (j = begin; j < end; j++)
-                    {
-                        double[] prob_estimates = new double[svm_get_nr_class(submodel)];
                         target[perm[j]] = svm_predict_probability(submodel, prob.X[perm[j]], prob_estimates);
-                        confidence[perm[j]] = new Dictionary<int, double>();
-                        for (int label = 0; label < prob_estimates.Length; label++)
-                            confidence[perm[j]][submodel.ClassLabels[label]] = prob_estimates[label];
-
-                    }
                 }
                 else
@@ -2171,5 +1998,5 @@
             else
             {
-                Debug.Write("Model doesn't contain information for SVR probability inference\n");
+                Console.Error.WriteLine("Model doesn't contain information for SVR probability inference");
                 return 0;
             }
@@ -2185,5 +2012,5 @@
                 double sum = 0;
                 for (int i = 0; i < model.SupportVectorCount; i++)
-                    sum += sv_coef[i] * Kernel.k_function(x, model.SupportVectors[i], model.Parameter);
+                    sum += sv_coef[i] * Kernel.KernelFunction(x, model.SupportVectors[i], model.Parameter);
                 sum -= model.Rho[0];
                 dec_values[0] = sum;
@@ -2197,5 +2024,5 @@
                 double[] kvalue = new double[l];
                 for (i = 0; i < l; i++)
-                    kvalue[i] = Kernel.k_function(x, model.SupportVectors[i], model.Parameter);
+                    kvalue[i] = Kernel.KernelFunction(x, model.SupportVectors[i], model.Parameter);
 
                 int[] start = new int[nr_class];
@@ -2262,53 +2089,45 @@
                     }
 
-                int vote_max_idx = 0;
+                int vote_Max_idx = 0;
                 for (i = 1; i < nr_class; i++)
-                    if (vote[i] > vote[vote_max_idx])
-                        vote_max_idx = i;
-                return model.ClassLabels[vote_max_idx];
+                    if (vote[i] > vote[vote_Max_idx])
+                        vote_Max_idx = i;
+                return model.ClassLabels[vote_Max_idx];
             }
         }
 
         public static double svm_predict_probability(Model model, Node[] x, double[] prob_estimates)
-	{
-        if ((model.Parameter.SvmType == SvmType.C_SVC || model.Parameter.SvmType == SvmType.NU_SVC) &&
-		    model.PairwiseProbabilityA!=null && model.PairwiseProbabilityB!=null)
-		{
-			int i;
-			int nr_class = model.NumberOfClasses;
-			double[] dec_values = new double[nr_class*(nr_class-1)/2];
-			svm_predict_values(model, x, dec_values);
-
-			double min_prob=1e-7;
-			double[,] pairwise_prob=new double[nr_class,nr_class];
-			
-			int k=0;
-			for(i=0;i<nr_class;i++)
-				for(int j=i+1;j<nr_class;j++)
-				{
-					pairwise_prob[i,j]=Math.Min(Math.Max(sigmoid_predict(dec_values[k],model.PairwiseProbabilityA[k],model.PairwiseProbabilityB[k]),min_prob),1-min_prob);
-					pairwise_prob[j,i]=1-pairwise_prob[i,j];
-					k++;
-				}
-			multiclass_probability(nr_class,pairwise_prob,prob_estimates);
-
-			int prob_max_idx = 0;
-			for(i=1;i<nr_class;i++)
-				if(prob_estimates[i] > prob_estimates[prob_max_idx])
-					prob_max_idx = i;
-			return model.ClassLabels[prob_max_idx];
-		}
-		else 
-			return svm_predict(model, x);
-	}
-
-        private static double atof(string s)
-        {
-            return double.Parse(s);
-        }
-
-        private static int atoi(string s)
-        {
-            return int.Parse(s);
+        {
+            if ((model.Parameter.SvmType == SvmType.C_SVC || model.Parameter.SvmType == SvmType.NU_SVC) &&
+                model.PairwiseProbabilityA != null && model.PairwiseProbabilityB != null)
+            {
+                int i;
+                int nr_class = model.NumberOfClasses;
+                double[] dec_values = new double[nr_class * (nr_class - 1) / 2];
+                svm_predict_values(model, x, dec_values);
+
+                double Min_prob = 1e-7;
+                double[,] pairwise_prob = new double[nr_class, nr_class];
+
+                int k = 0;
+                for (i = 0; i < nr_class; i++)
+                {
+                    for (int j = i + 1; j < nr_class; j++)
+                    {
+                        pairwise_prob[i, j] = Math.Min(Math.Max(sigmoid_predict(dec_values[k], model.PairwiseProbabilityA[k], model.PairwiseProbabilityB[k]), Min_prob), 1 - Min_prob);
+                        pairwise_prob[j, i] = 1 - pairwise_prob[i, j];
+                        k++;
+                    }
+                }
+                multiclass_probability(nr_class, pairwise_prob, prob_estimates);
+
+                int prob_Max_idx = 0;
+                for (i = 1; i < nr_class; i++)
+                    if (prob_estimates[i] > prob_estimates[prob_Max_idx])
+                        prob_Max_idx = i;
+                return model.ClassLabels[prob_Max_idx];
+            }
+            else
+                return svm_predict(model, x);
         }
 
